# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['StreamOnViewArgs', 'StreamOnView']

@pulumi.input_type
class StreamOnViewArgs:
    def __init__(__self__, *,
                 database: pulumi.Input[str],
                 schema: pulumi.Input[str],
                 view: pulumi.Input[str],
                 append_only: Optional[pulumi.Input[str]] = None,
                 at: Optional[pulumi.Input['StreamOnViewAtArgs']] = None,
                 before: Optional[pulumi.Input['StreamOnViewBeforeArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 copy_grants: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 show_initial_rows: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a StreamOnView resource.
        :param pulumi.Input[str] database: The database in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[str] schema: The schema in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[str] view: Specifies an identifier for the view the stream will monitor. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`. For more information about this resource, see docs.
        :param pulumi.Input[str] append_only: Specifies whether this is an append-only stream. Available options are: "true" or "false". When the value is not set in the configuration the provider will put "default" there which means to use the Snowflake default for this value.
        :param pulumi.Input[str] comment: Specifies a comment for the stream.
        :param pulumi.Input[str] name: Specifies the identifier for the stream; must be unique for the database and schema in which the stream is created. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "schema", schema)
        pulumi.set(__self__, "view", view)
        if append_only is not None:
            pulumi.set(__self__, "append_only", append_only)
        if at is not None:
            pulumi.set(__self__, "at", at)
        if before is not None:
            pulumi.set(__self__, "before", before)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if copy_grants is not None:
            pulumi.set(__self__, "copy_grants", copy_grants)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if show_initial_rows is not None:
            pulumi.set(__self__, "show_initial_rows", show_initial_rows)

    @property
    @pulumi.getter
    def database(self) -> pulumi.Input[str]:
        """
        The database in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "database")

    @database.setter
    def database(self, value: pulumi.Input[str]):
        pulumi.set(self, "database", value)

    @property
    @pulumi.getter
    def schema(self) -> pulumi.Input[str]:
        """
        The schema in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "schema")

    @schema.setter
    def schema(self, value: pulumi.Input[str]):
        pulumi.set(self, "schema", value)

    @property
    @pulumi.getter
    def view(self) -> pulumi.Input[str]:
        """
        Specifies an identifier for the view the stream will monitor. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`. For more information about this resource, see docs.
        """
        return pulumi.get(self, "view")

    @view.setter
    def view(self, value: pulumi.Input[str]):
        pulumi.set(self, "view", value)

    @property
    @pulumi.getter(name="appendOnly")
    def append_only(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies whether this is an append-only stream. Available options are: "true" or "false". When the value is not set in the configuration the provider will put "default" there which means to use the Snowflake default for this value.
        """
        return pulumi.get(self, "append_only")

    @append_only.setter
    def append_only(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "append_only", value)

    @property
    @pulumi.getter
    def at(self) -> Optional[pulumi.Input['StreamOnViewAtArgs']]:
        return pulumi.get(self, "at")

    @at.setter
    def at(self, value: Optional[pulumi.Input['StreamOnViewAtArgs']]):
        pulumi.set(self, "at", value)

    @property
    @pulumi.getter
    def before(self) -> Optional[pulumi.Input['StreamOnViewBeforeArgs']]:
        return pulumi.get(self, "before")

    @before.setter
    def before(self, value: Optional[pulumi.Input['StreamOnViewBeforeArgs']]):
        pulumi.set(self, "before", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a comment for the stream.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter(name="copyGrants")
    def copy_grants(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "copy_grants")

    @copy_grants.setter
    def copy_grants(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "copy_grants", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the identifier for the stream; must be unique for the database and schema in which the stream is created. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="showInitialRows")
    def show_initial_rows(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "show_initial_rows")

    @show_initial_rows.setter
    def show_initial_rows(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "show_initial_rows", value)


@pulumi.input_type
class _StreamOnViewState:
    def __init__(__self__, *,
                 append_only: Optional[pulumi.Input[str]] = None,
                 at: Optional[pulumi.Input['StreamOnViewAtArgs']] = None,
                 before: Optional[pulumi.Input['StreamOnViewBeforeArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 copy_grants: Optional[pulumi.Input[bool]] = None,
                 database: Optional[pulumi.Input[str]] = None,
                 describe_outputs: Optional[pulumi.Input[Sequence[pulumi.Input['StreamOnViewDescribeOutputArgs']]]] = None,
                 fully_qualified_name: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 schema: Optional[pulumi.Input[str]] = None,
                 show_initial_rows: Optional[pulumi.Input[str]] = None,
                 show_outputs: Optional[pulumi.Input[Sequence[pulumi.Input['StreamOnViewShowOutputArgs']]]] = None,
                 stale: Optional[pulumi.Input[bool]] = None,
                 stream_type: Optional[pulumi.Input[str]] = None,
                 view: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering StreamOnView resources.
        :param pulumi.Input[str] append_only: Specifies whether this is an append-only stream. Available options are: "true" or "false". When the value is not set in the configuration the provider will put "default" there which means to use the Snowflake default for this value.
        :param pulumi.Input[str] comment: Specifies a comment for the stream.
        :param pulumi.Input[str] database: The database in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[Sequence[pulumi.Input['StreamOnViewDescribeOutputArgs']]] describe_outputs: Outputs the result of `DESCRIBE STREAM` for the given stream.
        :param pulumi.Input[str] fully_qualified_name: Fully qualified name of the resource. For more information, see [object name resolution](https://docs.snowflake.com/en/sql-reference/name-resolution).
        :param pulumi.Input[str] name: Specifies the identifier for the stream; must be unique for the database and schema in which the stream is created. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[str] schema: The schema in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[Sequence[pulumi.Input['StreamOnViewShowOutputArgs']]] show_outputs: Outputs the result of `SHOW STREAMS` for the given stream.
        :param pulumi.Input[str] stream_type: Specifies a type for the stream. This field is used for checking external changes and recreating the resources if needed.
        :param pulumi.Input[str] view: Specifies an identifier for the view the stream will monitor. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`. For more information about this resource, see docs.
        """
        if append_only is not None:
            pulumi.set(__self__, "append_only", append_only)
        if at is not None:
            pulumi.set(__self__, "at", at)
        if before is not None:
            pulumi.set(__self__, "before", before)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if copy_grants is not None:
            pulumi.set(__self__, "copy_grants", copy_grants)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if describe_outputs is not None:
            pulumi.set(__self__, "describe_outputs", describe_outputs)
        if fully_qualified_name is not None:
            pulumi.set(__self__, "fully_qualified_name", fully_qualified_name)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)
        if show_initial_rows is not None:
            pulumi.set(__self__, "show_initial_rows", show_initial_rows)
        if show_outputs is not None:
            pulumi.set(__self__, "show_outputs", show_outputs)
        if stale is not None:
            pulumi.set(__self__, "stale", stale)
        if stream_type is not None:
            pulumi.set(__self__, "stream_type", stream_type)
        if view is not None:
            pulumi.set(__self__, "view", view)

    @property
    @pulumi.getter(name="appendOnly")
    def append_only(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies whether this is an append-only stream. Available options are: "true" or "false". When the value is not set in the configuration the provider will put "default" there which means to use the Snowflake default for this value.
        """
        return pulumi.get(self, "append_only")

    @append_only.setter
    def append_only(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "append_only", value)

    @property
    @pulumi.getter
    def at(self) -> Optional[pulumi.Input['StreamOnViewAtArgs']]:
        return pulumi.get(self, "at")

    @at.setter
    def at(self, value: Optional[pulumi.Input['StreamOnViewAtArgs']]):
        pulumi.set(self, "at", value)

    @property
    @pulumi.getter
    def before(self) -> Optional[pulumi.Input['StreamOnViewBeforeArgs']]:
        return pulumi.get(self, "before")

    @before.setter
    def before(self, value: Optional[pulumi.Input['StreamOnViewBeforeArgs']]):
        pulumi.set(self, "before", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a comment for the stream.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter(name="copyGrants")
    def copy_grants(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "copy_grants")

    @copy_grants.setter
    def copy_grants(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "copy_grants", value)

    @property
    @pulumi.getter
    def database(self) -> Optional[pulumi.Input[str]]:
        """
        The database in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "database")

    @database.setter
    def database(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database", value)

    @property
    @pulumi.getter(name="describeOutputs")
    def describe_outputs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['StreamOnViewDescribeOutputArgs']]]]:
        """
        Outputs the result of `DESCRIBE STREAM` for the given stream.
        """
        return pulumi.get(self, "describe_outputs")

    @describe_outputs.setter
    def describe_outputs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['StreamOnViewDescribeOutputArgs']]]]):
        pulumi.set(self, "describe_outputs", value)

    @property
    @pulumi.getter(name="fullyQualifiedName")
    def fully_qualified_name(self) -> Optional[pulumi.Input[str]]:
        """
        Fully qualified name of the resource. For more information, see [object name resolution](https://docs.snowflake.com/en/sql-reference/name-resolution).
        """
        return pulumi.get(self, "fully_qualified_name")

    @fully_qualified_name.setter
    def fully_qualified_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fully_qualified_name", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the identifier for the stream; must be unique for the database and schema in which the stream is created. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def schema(self) -> Optional[pulumi.Input[str]]:
        """
        The schema in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "schema")

    @schema.setter
    def schema(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "schema", value)

    @property
    @pulumi.getter(name="showInitialRows")
    def show_initial_rows(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "show_initial_rows")

    @show_initial_rows.setter
    def show_initial_rows(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "show_initial_rows", value)

    @property
    @pulumi.getter(name="showOutputs")
    def show_outputs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['StreamOnViewShowOutputArgs']]]]:
        """
        Outputs the result of `SHOW STREAMS` for the given stream.
        """
        return pulumi.get(self, "show_outputs")

    @show_outputs.setter
    def show_outputs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['StreamOnViewShowOutputArgs']]]]):
        pulumi.set(self, "show_outputs", value)

    @property
    @pulumi.getter
    def stale(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "stale")

    @stale.setter
    def stale(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "stale", value)

    @property
    @pulumi.getter(name="streamType")
    def stream_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a type for the stream. This field is used for checking external changes and recreating the resources if needed.
        """
        return pulumi.get(self, "stream_type")

    @stream_type.setter
    def stream_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stream_type", value)

    @property
    @pulumi.getter
    def view(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies an identifier for the view the stream will monitor. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`. For more information about this resource, see docs.
        """
        return pulumi.get(self, "view")

    @view.setter
    def view(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "view", value)


class StreamOnView(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 append_only: Optional[pulumi.Input[str]] = None,
                 at: Optional[pulumi.Input[Union['StreamOnViewAtArgs', 'StreamOnViewAtArgsDict']]] = None,
                 before: Optional[pulumi.Input[Union['StreamOnViewBeforeArgs', 'StreamOnViewBeforeArgsDict']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 copy_grants: Optional[pulumi.Input[bool]] = None,
                 database: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 schema: Optional[pulumi.Input[str]] = None,
                 show_initial_rows: Optional[pulumi.Input[str]] = None,
                 view: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Import

        ```sh
        $ pulumi import snowflake:index/streamOnView:StreamOnView example '"<database_name>"."<schema_name>"."<stream_name>"'
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] append_only: Specifies whether this is an append-only stream. Available options are: "true" or "false". When the value is not set in the configuration the provider will put "default" there which means to use the Snowflake default for this value.
        :param pulumi.Input[str] comment: Specifies a comment for the stream.
        :param pulumi.Input[str] database: The database in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[str] name: Specifies the identifier for the stream; must be unique for the database and schema in which the stream is created. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[str] schema: The schema in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[str] view: Specifies an identifier for the view the stream will monitor. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`. For more information about this resource, see docs.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: StreamOnViewArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Import

        ```sh
        $ pulumi import snowflake:index/streamOnView:StreamOnView example '"<database_name>"."<schema_name>"."<stream_name>"'
        ```

        :param str resource_name: The name of the resource.
        :param StreamOnViewArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(StreamOnViewArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 append_only: Optional[pulumi.Input[str]] = None,
                 at: Optional[pulumi.Input[Union['StreamOnViewAtArgs', 'StreamOnViewAtArgsDict']]] = None,
                 before: Optional[pulumi.Input[Union['StreamOnViewBeforeArgs', 'StreamOnViewBeforeArgsDict']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 copy_grants: Optional[pulumi.Input[bool]] = None,
                 database: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 schema: Optional[pulumi.Input[str]] = None,
                 show_initial_rows: Optional[pulumi.Input[str]] = None,
                 view: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = StreamOnViewArgs.__new__(StreamOnViewArgs)

            __props__.__dict__["append_only"] = append_only
            __props__.__dict__["at"] = at
            __props__.__dict__["before"] = before
            __props__.__dict__["comment"] = comment
            __props__.__dict__["copy_grants"] = copy_grants
            if database is None and not opts.urn:
                raise TypeError("Missing required property 'database'")
            __props__.__dict__["database"] = database
            __props__.__dict__["name"] = name
            if schema is None and not opts.urn:
                raise TypeError("Missing required property 'schema'")
            __props__.__dict__["schema"] = schema
            __props__.__dict__["show_initial_rows"] = show_initial_rows
            if view is None and not opts.urn:
                raise TypeError("Missing required property 'view'")
            __props__.__dict__["view"] = view
            __props__.__dict__["describe_outputs"] = None
            __props__.__dict__["fully_qualified_name"] = None
            __props__.__dict__["show_outputs"] = None
            __props__.__dict__["stale"] = None
            __props__.__dict__["stream_type"] = None
        super(StreamOnView, __self__).__init__(
            'snowflake:index/streamOnView:StreamOnView',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            append_only: Optional[pulumi.Input[str]] = None,
            at: Optional[pulumi.Input[Union['StreamOnViewAtArgs', 'StreamOnViewAtArgsDict']]] = None,
            before: Optional[pulumi.Input[Union['StreamOnViewBeforeArgs', 'StreamOnViewBeforeArgsDict']]] = None,
            comment: Optional[pulumi.Input[str]] = None,
            copy_grants: Optional[pulumi.Input[bool]] = None,
            database: Optional[pulumi.Input[str]] = None,
            describe_outputs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['StreamOnViewDescribeOutputArgs', 'StreamOnViewDescribeOutputArgsDict']]]]] = None,
            fully_qualified_name: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            schema: Optional[pulumi.Input[str]] = None,
            show_initial_rows: Optional[pulumi.Input[str]] = None,
            show_outputs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['StreamOnViewShowOutputArgs', 'StreamOnViewShowOutputArgsDict']]]]] = None,
            stale: Optional[pulumi.Input[bool]] = None,
            stream_type: Optional[pulumi.Input[str]] = None,
            view: Optional[pulumi.Input[str]] = None) -> 'StreamOnView':
        """
        Get an existing StreamOnView resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] append_only: Specifies whether this is an append-only stream. Available options are: "true" or "false". When the value is not set in the configuration the provider will put "default" there which means to use the Snowflake default for this value.
        :param pulumi.Input[str] comment: Specifies a comment for the stream.
        :param pulumi.Input[str] database: The database in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[Sequence[pulumi.Input[Union['StreamOnViewDescribeOutputArgs', 'StreamOnViewDescribeOutputArgsDict']]]] describe_outputs: Outputs the result of `DESCRIBE STREAM` for the given stream.
        :param pulumi.Input[str] fully_qualified_name: Fully qualified name of the resource. For more information, see [object name resolution](https://docs.snowflake.com/en/sql-reference/name-resolution).
        :param pulumi.Input[str] name: Specifies the identifier for the stream; must be unique for the database and schema in which the stream is created. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[str] schema: The schema in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        :param pulumi.Input[Sequence[pulumi.Input[Union['StreamOnViewShowOutputArgs', 'StreamOnViewShowOutputArgsDict']]]] show_outputs: Outputs the result of `SHOW STREAMS` for the given stream.
        :param pulumi.Input[str] stream_type: Specifies a type for the stream. This field is used for checking external changes and recreating the resources if needed.
        :param pulumi.Input[str] view: Specifies an identifier for the view the stream will monitor. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`. For more information about this resource, see docs.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _StreamOnViewState.__new__(_StreamOnViewState)

        __props__.__dict__["append_only"] = append_only
        __props__.__dict__["at"] = at
        __props__.__dict__["before"] = before
        __props__.__dict__["comment"] = comment
        __props__.__dict__["copy_grants"] = copy_grants
        __props__.__dict__["database"] = database
        __props__.__dict__["describe_outputs"] = describe_outputs
        __props__.__dict__["fully_qualified_name"] = fully_qualified_name
        __props__.__dict__["name"] = name
        __props__.__dict__["schema"] = schema
        __props__.__dict__["show_initial_rows"] = show_initial_rows
        __props__.__dict__["show_outputs"] = show_outputs
        __props__.__dict__["stale"] = stale
        __props__.__dict__["stream_type"] = stream_type
        __props__.__dict__["view"] = view
        return StreamOnView(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="appendOnly")
    def append_only(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies whether this is an append-only stream. Available options are: "true" or "false". When the value is not set in the configuration the provider will put "default" there which means to use the Snowflake default for this value.
        """
        return pulumi.get(self, "append_only")

    @property
    @pulumi.getter
    def at(self) -> pulumi.Output[Optional['outputs.StreamOnViewAt']]:
        return pulumi.get(self, "at")

    @property
    @pulumi.getter
    def before(self) -> pulumi.Output[Optional['outputs.StreamOnViewBefore']]:
        return pulumi.get(self, "before")

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies a comment for the stream.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="copyGrants")
    def copy_grants(self) -> pulumi.Output[Optional[bool]]:
        return pulumi.get(self, "copy_grants")

    @property
    @pulumi.getter
    def database(self) -> pulumi.Output[str]:
        """
        The database in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter(name="describeOutputs")
    def describe_outputs(self) -> pulumi.Output[Sequence['outputs.StreamOnViewDescribeOutput']]:
        """
        Outputs the result of `DESCRIBE STREAM` for the given stream.
        """
        return pulumi.get(self, "describe_outputs")

    @property
    @pulumi.getter(name="fullyQualifiedName")
    def fully_qualified_name(self) -> pulumi.Output[str]:
        """
        Fully qualified name of the resource. For more information, see [object name resolution](https://docs.snowflake.com/en/sql-reference/name-resolution).
        """
        return pulumi.get(self, "fully_qualified_name")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Specifies the identifier for the stream; must be unique for the database and schema in which the stream is created. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> pulumi.Output[str]:
        """
        The schema in which to create the stream. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`.
        """
        return pulumi.get(self, "schema")

    @property
    @pulumi.getter(name="showInitialRows")
    def show_initial_rows(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "show_initial_rows")

    @property
    @pulumi.getter(name="showOutputs")
    def show_outputs(self) -> pulumi.Output[Sequence['outputs.StreamOnViewShowOutput']]:
        """
        Outputs the result of `SHOW STREAMS` for the given stream.
        """
        return pulumi.get(self, "show_outputs")

    @property
    @pulumi.getter
    def stale(self) -> pulumi.Output[bool]:
        return pulumi.get(self, "stale")

    @property
    @pulumi.getter(name="streamType")
    def stream_type(self) -> pulumi.Output[str]:
        """
        Specifies a type for the stream. This field is used for checking external changes and recreating the resources if needed.
        """
        return pulumi.get(self, "stream_type")

    @property
    @pulumi.getter
    def view(self) -> pulumi.Output[str]:
        """
        Specifies an identifier for the view the stream will monitor. Due to technical limitations (read more here), avoid using the following characters: `|`, `.`, `"`. For more information about this resource, see docs.
        """
        return pulumi.get(self, "view")

